## liblastfm 1.2.0~git20250222.81e8f9d

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)
project(liblastfm)

# general settings
set(LASTFM_SOVERSION 1)
set(LASTFM_VERSION "0x00010200")

set(LASTFM_MAJOR_VERSION "1")
set(LASTFM_MINOR_VERSION "2")
set(LASTFM_PATCH_VERSION "0")
set(LASTFM_VERSION_STRING "${LASTFM_MAJOR_VERSION}.${LASTFM_MINOR_VERSION}.${LASTFM_PATCH_VERSION}")

# options
option(BUILD_FINGERPRINT "Build the lastfm-fingerprint library" ON)
option(BUILD_DEMOS "Build the lastfm example programs" OFF)
option(BUILD_TESTS "Build liblastfm tests" ON)


# installation dirs
include(GNUInstallDirs)
include(FeatureSummary)
include(FindPkgConfig)

# setup qt stuff
set(CMAKE_AUTOMOC ON)

option(BUILD_WITH_QT5 "Build liblastfm with Qt5" OFF)

if(NOT BUILD_WITH_QT5)
    find_package(Qt6 CONFIG REQUIRED COMPONENTS Core Network Xml)

    if(BUILD_FINGERPRINT)
        find_package(Qt6Sql CONFIG REQUIRED)
    endif()

    if(BUILD_TESTS)
        find_package(Qt6Test CONFIG REQUIRED)
    endif()

    set(LASTFM_LIB_VERSION_SUFFIX 6)

    if(UNIX AND NOT APPLE)
        find_package(Qt6DBus CONFIG REQUIRED)
    endif()
else()
    find_package(Qt5 CONFIG REQUIRED COMPONENTS Core Network Xml)

    if(BUILD_FINGERPRINT)
        find_package(Qt5Sql CONFIG REQUIRED)
    endif()

    if(BUILD_TESTS)
        find_package(Qt5Test CONFIG REQUIRED)
    endif()

    set(LASTFM_LIB_VERSION_SUFFIX 5)

    if(UNIX AND NOT APPLE)
        find_package(Qt5DBus CONFIG REQUIRED)
    endif()
endif()

if(BUILD_FINGERPRINT)
    pkg_check_modules(LibSamplerate REQUIRED IMPORTED_TARGET samplerate)
    add_feature_info(LibSamplerate LibSamplerate_FOUND "Required for lastfm-fingerprint library")

    pkg_check_modules(FFTW3F REQUIRED IMPORTED_TARGET fftw3f>=3.0)
    add_feature_info(FFTW3F FFTW3F_FOUND "Required for lastfm-fingerprint library")
endif()

if(CMAKE_COMPILER_IS_GNUCXX)
    add_definitions("-fno-operator-names -fvisibility-inlines-hidden -fvisibility=hidden")
endif()
if(UNIX AND NOT APPLE)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wl,--no-undefined")
endif()

if(MSVC)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /Zc:wchar_t-")
endif(MSVC)

set(LASTFM_LIB_TARGET_NAME lastfm${LASTFM_LIB_VERSION_SUFFIX} CACHE
    INTERNAL "Target name of liblastfm" FORCE)

set(FINGERPRINT_LIB_TARGET_NAME lastfm_fingerprint${LASTFM_LIB_VERSION_SUFFIX} CACHE
    INTERNAL "Target name of liblastfm_fingerprint" FORCE)

# main library
add_subdirectory(src)

# lastfm_fingerprint library
if(BUILD_FINGERPRINT)
    add_subdirectory(src/fingerprint)
endif()

# demos
if(BUILD_DEMOS)
    add_subdirectory(demos)
endif()

# tests
if(BUILD_TESTS)
    enable_testing()
    add_subdirectory(tests)
endif()

feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== src/CMakeLists.txt ===
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/global.h.in ${CMAKE_CURRENT_BINARY_DIR}/global.h)

include_directories(${CMAKE_CURRENT_BINARY_DIR})

set(liblastfm_SOURCES
        ws.cpp
        NetworkConnectionMonitor.cpp
        NetworkAccessManager.cpp
        InternetConnectionMonitor.cpp
        Xspf.cpp
        User.cpp
        Track.cpp
        Tasteometer.cpp
        Tag.cpp
        Playlist.cpp
        Mbid.cpp
        FingerprintId.cpp
        Artist.cpp
        Album.cpp
        ScrobbleCache.cpp
        ScrobblePoint.cpp
        Audioscrobbler.cpp
        RadioTuner.cpp
        RadioStation.cpp
        XmlQuery.cpp
        Url.cpp
        UrlBuilder.cpp
        misc.cpp
        Chart.cpp
        Auth.cpp
        Library.cpp
)

if(WIN32)
    add_definitions("-DWIN32_LEAN_AND_MEAN")

    if(NOT MINGW)
        add_definitions("-D_ATL_DLL -D_CRT_SECURE_NO_WARNINGS")

        set(liblastfm_SOURCES ${liblastfm_SOURCES}
            win/WNetworkConnectionMonitor_win.cpp
            win/WmiSink.cpp
            win/NdisEvents.cpp
        )
    endif()
endif()

if(APPLE)
    #FIXME: enable this when deploying
    #set(CMAKE_OSX_ARCHITECTURES "i386;ppc")
    #set(CMAKE_OSX_DEPLOYMENT_TARGET 10.5)
    #set(CMAKE_OSX_SYSROOT "/Developer/SDKs/MacOSX${CMAKE_OSX_DEPLOYMENT_TARGET}.sdk")

    set(liblastfm_SOURCES ${liblastfm_SOURCES}
        mac/MNetworkConnectionMonitor_mac.cpp
    )
endif()

if(UNIX AND NOT APPLE)
    set(liblastfm_SOURCES ${liblastfm_SOURCES}
        linux/LNetworkConnectionMonitor_linux.cpp
    )
endif()

add_library(${LASTFM_LIB_TARGET_NAME} SHARED ${liblastfm_SOURCES})

target_link_libraries(${LASTFM_LIB_TARGET_NAME} Qt::Network Qt::Xml)
if(UNIX AND NOT APPLE)
    target_link_libraries(${LASTFM_LIB_TARGET_NAME} Qt::DBus)
endif()

if(WIN32 AND NOT MINGW)
    target_link_libraries(${LASTFM_LIB_TARGET_NAME}
        winhttp
        wbemuuid
    )
endif()

if(APPLE)
    find_library(SYSTEMCONFIGURATION_LIBRARY SystemConfiguration)
    find_library(COREFOUNDATION_LIBRARY CoreFoundation)
    target_link_libraries(${LASTFM_LIB_TARGET_NAME}
        ${COREFOUNDATION_LIBRARY}
        ${SYSTEMCONFIGURATION_LIBRARY}
    )
endif()

set_target_properties(${LASTFM_LIB_TARGET_NAME} PROPERTIES
    VERSION ${LASTFM_VERSION_STRING}
    SOVERSION ${LASTFM_SOVERSION}
    COMPILE_DEFINITIONS LASTFM_LIB
)

if(WIN32)
    set_target_properties(${LASTFM_LIB_TARGET_NAME} PROPERTIES
        RUNTIME_OUTPUT_NAME "${LASTFM_LIB_TARGET_NAME}-${LASTFM_SOVERSION}")
endif()

install(TARGETS ${LASTFM_LIB_TARGET_NAME}
    EXPORT "${LASTFM_LIB_TARGET_NAME}Config"
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

install(EXPORT "${LASTFM_LIB_TARGET_NAME}Config"
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/lastfm${LASTFM_LIB_VERSION_SUFFIX}
    NAMESPACE LASTFM::
)

file(GLOB liblastfm_HEADERS ${CMAKE_CURRENT_LIST_DIR}/*.h)
list(APPEND liblastfm_HEADERS ${CMAKE_CURRENT_BINARY_DIR}/global.h)
install(FILES ${liblastfm_HEADERS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/lastfm${LASTFM_LIB_VERSION_SUFFIX}/)

=== tests/CMakeLists.txt ===
include(lastfm_add_test.cmake)
include_directories(${CMAKE_CURRENT_BINARY_DIR}/../src)

lastfm_add_test(UrlBuilder)
lastfm_add_test(Track)

=== src/fingerprint/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_LIST_DIR}/..)
include_directories(${CMAKE_CURRENT_BINARY_DIR}/..)

set(lastfm_fingerprint_SOURCES
  Collection.cpp
  Fingerprint.cpp
  Sha256.cpp
  fplib/Filter.cpp
  fplib/FingerprintExtractor.cpp
  fplib/OptFFT.cpp
)

set(lastfm_fingerprint_HEADERS
    Fingerprint.h
    FingerprintableSource.h
)

add_library(${FINGERPRINT_LIB_TARGET_NAME} SHARED ${lastfm_fingerprint_SOURCES})

set_target_properties(${FINGERPRINT_LIB_TARGET_NAME} PROPERTIES
    COMPILE_DEFINITIONS LASTFM_FINGERPRINT_LIB
    VERSION ${LASTFM_VERSION_STRING}
    SOVERSION ${LASTFM_SOVERSION}
)

if(WIN32)
    set_target_properties(${FINGERPRINT_LIB_TARGET_NAME} PROPERTIES
        RUNTIME_OUTPUT_NAME "${FINGERPRINT_LIB_TARGET_NAME}-${LASTFM_SOVERSION}")
endif()

target_link_libraries(${FINGERPRINT_LIB_TARGET_NAME}
    ${LASTFM_LIB_TARGET_NAME}
    PkgConfig::LibSamplerate
    PkgConfig::FFTW3F
)

target_link_libraries(${FINGERPRINT_LIB_TARGET_NAME} Qt::Network Qt::Sql Qt::Xml)

install(TARGETS ${FINGERPRINT_LIB_TARGET_NAME}
    EXPORT "${FINGERPRINT_LIB_TARGET_NAME}Config"
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

install(EXPORT "${FINGERPRINT_LIB_TARGET_NAME}Config"
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/lastfm${LASTFM_LIB_VERSION_SUFFIX}
    NAMESPACE LASTFM::
)

install(FILES ${lastfm_fingerprint_HEADERS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/lastfm${LASTFM_LIB_VERSION_SUFFIX}/)

=== debian/changelog ===
liblastfm (1.2.0~git20250222.81e8f9d-2) unstable; urgency=medium

  [ Aurélien COUDERC ]
  * Drop Rules-Requires-Root: no, not needed anymore since trixie.
  * Update upstream links to the Qt6 fork currently being used.
  * wrap-and-sort debian/control.
  * Bump Standards-Version to 4.7.3, no change required.
  * Drop Priority: optional, not needed anymore since dpkg 1.22.13.

 -- Aurélien COUDERC <coucouf@debian.org>  Tue, 17 Feb 2026 17:50:10 +0100

liblastfm (1.2.0~git20250222.81e8f9d-1) unstable; urgency=medium

  [ Aurélien COUDERC ]
  * Import new upstream git snapshot having the Qt 6 port from
    https://github.com/Mazhoon/liblastfm (1.2.0~git20250222.81e8f9d).
  * Update build-deps and deps with the info from cmake.
  * Drop patch applied upstream.
  * Switch to declarative dh-sequence-pkgkde-symbolshelper.
  * Cleanup debian/rules.
  * Also install cmake files.
  * Update symbols from build for 1.2.0~git20250222.81e8f9d.
  * Dual Qt5 / Qt6 build.
  * Bump Standards-Version to 4.7.2, no change required.
  * Drop unused liblastfm5-dev.docs file.
  * Adopt the package under the Debian KDE Extras Team’s umbrella.

 -- Aurélien COUDERC <coucouf@debian.org>  Sat, 16 Aug 2025 17:16:32 +0200

=== debian/control ===
Source: liblastfm
Section: libs
Maintainer: Debian KDE Extras Team <pkg-kde-extras@alioth-lists.debian.net>
Uploaders: Aurélien COUDERC <coucouf@debian.org>,
Build-Depends: debhelper-compat (= 13),
               dh-sequence-pkgkde-symbolshelper,
               cmake (>= 3.6~),
               libfftw3-dev,
               libsamplerate0-dev,
               pkg-kde-tools,
               qt6-base-dev,
               qtbase5-dev,
Standards-Version: 4.7.3
Homepage: https://github.com/Mazhoon/liblastfm/
Vcs-Git: https://salsa.debian.org/qt-kde-team/3rdparty/liblastfm.git
Vcs-Browser: https://salsa.debian.org/qt-kde-team/3rdparty/liblastfm

Package: liblastfm-fingerprint5-1
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Last.fm fingerprinting library (Qt5 build)
 liblastfm is a collection of C++/Qt5 libraries provided by Last.fm for use
 with their web services.
 .
 This library lets you fingerprint decoded audio tracks and fetch metadata
 suggestions for them.

Package: liblastfm5-1
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Last.fm web services library (Qt5 build)
 liblastfm is a collection of C++/Qt5 libraries provided by Last.fm for use
 with their web services.
 .
 This package contains the base web services library.

Package: liblastfm5-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: liblastfm-fingerprint5-1 (= ${binary:Version}),
         liblastfm5-1 (= ${binary:Version}),
         ${misc:Depends},
Description: Last.fm web services library (Qt5 build) - development files
 liblastfm is a collection of C++/Qt5 libraries provided by Last.fm for use
 with their web services.
 .
 This package contains the development files. Developers working on a new
 client will need to request an API key. See README for more details.

Package: liblastfm-fingerprint6-1
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Last.fm fingerprinting library (Qt6 build)
 liblastfm is a collection of C++/Qt6 libraries provided by Last.fm for use
 with their web services.
 .
 This library lets you fingerprint decoded audio tracks and fetch metadata
 suggestions for them.

Package: liblastfm6-1
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Last.fm web services library (Qt6 build)
 liblastfm is a collection of C++/Qt6 libraries provided by Last.fm for use
 with their web services.
 .
 This package contains the base web services library.

Package: liblastfm6-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: liblastfm-fingerprint6-1 (= ${binary:Version}),
         liblastfm6-1 (= ${binary:Version}),
         ${misc:Depends},
Description: Last.fm web services library (Qt6 build) - development files
 liblastfm is a collection of C++/Qt6 libraries provided by Last.fm for use
 with their web services.
 .
 This package contains the development files. Developers working on a new
 client will need to request an API key. See README for more details.

=== debian/watch ===
Version: 5
Template: GitHub
Owner: Mazhoon
Project: liblastfm
